Package org.apache.sis.metadata.iso.spatial

## Class DefaultGCP

- Object
- - AbstractMetadata
  - - ModifiableMetadata
    - - ISOMetadata
      - - DefaultGCP

- All Implemented Interfaces:
    `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `GCP`

      public class DefaultGCP
      extends ISOMetadata
      implements GCP

  Information on ground control point. Ground control points (GCP) are large marked targets on the ground, not to be confused with localization grid points embedded in some file formats like GeoTIFF or netCDF. The following property is mandatory in a well-formed metadata according ISO 19115:
  `MI_GCP` `└─geographicCoordinates……` Geographic or map position of the control point, in either two or three dimensions.

  Limitations:

  - Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
  - Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.
  Since:
    0.3
  See Also:
    `DefaultGCPCollection`, Serialized Form

  Defined in the `sis-metadata` module

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class ModifiableMetadata

      `ModifiableMetadata​.State`

  - ### Field Summary

    - ### Fields inherited from class ISOMetadata

      `identifiers`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DefaultGCP()` | Constructs an initially empty ground control point.
    `DefaultGCP​(GCP object)` | Constructs a new instance initialized with the values from the specified metadata object.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static DefaultGCP` | `castOrCopy​(GCP object)` | Returns a SIS metadata implementation with the values of the given arbitrary implementation.
    `Collection<Element>` | `getAccuracyReports()` | Returns the accuracy of a ground control point.
    `DirectPosition` | `getGeographicCoordinates()` | Returns the geographic or map position of the control point, in either two or three dimensions.
    `void` | `setAccuracyReports​(Collection<? extends Element> newValues)` | Sets the accuracy of a ground control point.
    `void` | `setGeographicCoordinates​(DirectPosition newValue)` | Sets the geographic or map position of the control point, in either two or three dimensions.

    - ### Methods inherited from class ISOMetadata

      `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

    - ### Methods inherited from class ModifiableMetadata

      `checkWritePermission, checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, freeze, isModifiable, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, unmodifiable, writeCollection, writeList, writeMap, writeSet`

    - ### Methods inherited from class AbstractMetadata

      `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

    - ### Methods inherited from class Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultGCP

          public DefaultGCP()

      Constructs an initially empty ground control point.

    - #### DefaultGCP

          public DefaultGCP​(GCP object)

      Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the metadata to copy values from, or `null` if none.
      See Also:
        `castOrCopy(GCP)`

  - ### Method Detail

    - #### castOrCopy

          public static DefaultGCP castOrCopy​(GCP object)

      Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
      - If the given object is `null`, then this method returns `null`.
      - Otherwise if the given object is already an instance of `DefaultGCP`, then it is returned unchanged.
      - Otherwise a new `DefaultGCP` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getGeographicCoordinates

          public DirectPosition getGeographicCoordinates()

      Returns the geographic or map position of the control point, in either two or three dimensions.
      Specified by:
        `getGeographicCoordinates` in interface `GCP`
      Returns:
        geographic or map position of the control point, or `null`.
      TODO:
        finish the annotation on the referencing module before.

    - #### setGeographicCoordinates

          public void setGeographicCoordinates​(DirectPosition newValue)

      Sets the geographic or map position of the control point, in either two or three dimensions.
      Parameters:
        `newValue` - the new geographic coordinates values.

    - #### getAccuracyReports

          public Collection<Element> getAccuracyReports()

      Returns the accuracy of a ground control point.
      Specified by:
        `getAccuracyReports` in interface `GCP`
      Returns:
        accuracy of a ground control point.

    - #### setAccuracyReports

          public void setAccuracyReports​(Collection<? extends Element> newValues)

      Sets the accuracy of a ground control point.
      Parameters:
        `newValues` - the new accuracy report values.